<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$v" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <!--Contenido-->
    <div class="blanco">
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            Nombre del Modelo
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              v-model.trim="modelo.nombre_modelo"
              maxlength="50"
              outlined
              solo
              flat
              dense
              :error="$v.modeloVuelidate.nombre_modelo.$error"
              hint-align="right"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(modelo.nombre_modelo, 50)
              "
              background-color="white"
            >
              <template
                v-if="$v.modeloVuelidate.nombre_modelo.$error"
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.modeloVuelidate.nombre_modelo.$reset()"
                      v-close-popover
                    >
                      <div v-if="!$v.modeloVuelidate.nombre_modelo.required">
                        ¡No te olvides de éste campo!
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
        </v-row>
      </div>
    </div>
    <template>
      <template v-if="!isEditingEje">
        <v-sheet class="overflow-y-auto CardScroll" style="background : none;">
          <v-row>
            <v-col
              :offset-md="1"
              :offset-lg="1"
              :offset-xl="3"
              :sm="12"
              :md="10"
              :lg="10"
              :xl="6"
            >
              <template v-if="notEjes">
                <v-card class="mt-5" height="100" color="#faf9f9" flat></v-card>
                <v-card class="mt-5" height="100" color="#faf9f9" flat></v-card>
              </template>
              <template
                v-for="(ejeModelo, indexEjeModelo) in ejesActiveModelo()"
              >
                <v-card
                  :key="indexEjeModelo"
                  color="#f9f9f9"
                  flat
                  :class="[{ 'mt-5': indexEjeModelo !== 0 }]"
                >
                  <v-btn
                    @click="
                      tempIndexEjeModeloDeleting = indexEjeModelo;
                      tempDeletingEjeModelo = ejeModelo;
                      dialogDelete = true;
                    "
                    x-small
                    class="float-right mt-2 mr-4"
                    text
                    icon
                  >
                    <v-img
                      :contain="true"
                      :aspect-ratio="1"
                      position="center"
                      src="@/assets/img/delete.svg"
                      class="white--text align-end"
                    ></v-img>
                  </v-btn>
                  <v-row>
                    <v-col :cols="12" :xs="12" :sm="12" :md="6" :lg="6" :xl="6">
                      Nombre del eje
                      <span class="tRojo">*</span>
                      <v-autocomplete
                        v-if="!isEditingEje"
                        class="mt-0 pt-1"
                        placeholder="Nombre del eje"
                        v-model="ejeModelo.id_eje"
                        :hide-no-data="!ejeModelo.search_eje"
                        :items="avalibleEjes"
                        item-disabled="disabled"
                        item-text="descripcion"
                        item-value="id_eje"
                        :search-input.sync="ejeModelo.search_eje"
                        background-color="white"
                        persistent-hint
                        small-chips
                        clearable
                        :error="
                          $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                            .id_eje.$error
                        "
                      >
                        <template v-slot:no-data>
                          <v-list-item>
                            <v-list-item-content>
                              <v-list-item-title>
                                No se encontraron resultados "
                                <strong>{{ ejeModelo.search_eje }}</strong
                                >".
                                <v-btn
                                  x-small
                                  class="black--text"
                                  dark
                                  tile
                                  color="primary"
                                  @click="
                                    editTempEje({
                                      descripcion: ejeModelo.search_eje
                                    })
                                  "
                                >
                                  <v-avatar size="15" tile>
                                    <v-img
                                      :contain="true"
                                      :aspect-ratio="1"
                                      position="center"
                                      src="@/assets/img/icoSimpleAgregar.svg"
                                      class="black--text"
                                    ></v-img> </v-avatar
                                  >Agregar
                                </v-btn>
                              </v-list-item-title>
                            </v-list-item-content>
                          </v-list-item>
                        </template>
                        <template
                          v-slot:selection="{ attrs, item, parent, selected }"
                        >
                          <v-chip
                            v-if="item === Object(item)"
                            v-bind="attrs"
                            :input-value="selected"
                            :color="!selected ? 'primary' : ''"
                            label
                            small
                          >
                            <span class="pr-2">{{ item.descripcion }}</span>
                          </v-chip>
                        </template>
                        <template v-slot:item="{ index, item }">
                          <v-chip dark label small>{{
                            item.descripcion
                          }}</v-chip>
                          <v-spacer></v-spacer>
                          <v-list-item-action @click.stop>
                            <v-btn
                              icon
                              @keyup.stop.prevent="editTempEje(item)"
                              @click.stop.prevent="editTempEje(item)"
                            >
                              <v-icon>mdi-pencil</v-icon>
                            </v-btn>
                          </v-list-item-action>
                        </template>
                        <template
                          v-if="
                            $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                              .id_eje.$error
                          "
                          v-slot:append-outer
                        >
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <span
                                @click="
                                  $v.modeloVuelidate.ejes_modelo.$each[
                                    indexEjeModelo
                                  ].id_eje.$reset()
                                "
                                v-close-popover
                              >
                                <span
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].id_eje.required
                                  "
                                  >¡No te olvides de éste campo!</span
                                >
                              </span>
                            </template>
                          </v-popover>
                        </template>
                      </v-autocomplete>
                    </v-col>
                    <v-col :cols="12" :xs="12" :sm="12" :md="6" :lg="6" :xl="6">
                      Ponderación
                      <span class="tRojo">*</span>
                      <v-text-field
                        v-model.number="ejeModelo.ponderacion"
                        class="mt-0 pt-1"
                        v-number
                        placeholder="Ponderación"
                        maxlength="3"
                        background-color="white"
                        hint-align="right"
                        :hint="
                          totalPonderacionEjesRestante === 0
                            ? ''
                            : totalPonderacionEjesRestante > 0
                            ? 'FALTA ' + totalPonderacionEjesRestante
                            : 'SOBRA ' + -totalPonderacionEjesRestante
                        "
                        :error="
                          $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                            .ponderacion.$error
                        "
                      >
                        <template
                          v-if="
                            $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                              .ponderacion.$error
                          "
                          v-slot:append
                        >
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <div
                                @click="
                                  $v.modeloVuelidate.ejes_modelo.$each[
                                    indexEjeModelo
                                  ].ponderacion.$reset()
                                "
                                v-close-popover
                              >
                                <div
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].ponderacion.required
                                  "
                                >
                                  *¡No te olvides de éste campo!
                                </div>
                                <div
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].ponderacion.greaterZero
                                  "
                                >
                                  *¡El valor debe ser mayor a 0!
                                </div>
                                <div
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].ponderacion.ponderacionFaltante
                                  "
                                >
                                  *¡El valor faltante es
                                  {{ totalPonderacionEjesRestante }}!
                                </div>
                                <div
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].ponderacion.ponderacionSobrante
                                  "
                                >
                                  *¡El valor sobrante es
                                  {{ -totalPonderacionEjesRestante }}!
                                </div>
                              </div>
                            </template>
                          </v-popover>
                        </template>
                      </v-text-field>
                    </v-col>
                  </v-row>
                </v-card>
              </template>
            </v-col>
          </v-row>
          <v-row>
            <v-col
              :offset-md="1"
              :offset-lg="1"
              :offset-xl="3"
              :xs="12"
              :sm="12"
              :md="10"
              :lg="10"
              :xl="6"
            >
              <div class="btnAgregar">
                <v-btn
                  small
                  class="black--text"
                  dark
                  tile
                  color="white"
                  @click="addNewTempEjeModelo"
                >
                  <v-avatar size="20" tile>
                    <v-img
                      :contain="true"
                      :aspect-ratio="1"
                      position="center"
                      src="@/assets/img/icoSimpleAgregar.svg"
                      class="black--text"
                    ></v-img> </v-avatar
                  >Nuevo eje
                </v-btn>
              </div>
            </v-col>
          </v-row>
          <v-row>
            <v-col
              :offset-md="1"
              :offset-lg="1"
              :offset-xl="3"
              :xs="12"
              :sm="12"
              :md="10"
              :lg="10"
              :xl="6"
            >
              <v-card elevation="0">
                <v-row>
                  <v-col
                    :offset-sm="7"
                    :offset-md="7"
                    :offset-xl="8"
                    :offset-lg="8"
                    :cols="12"
                    :xs="12"
                    :sm="5"
                    :md="5"
                    :lg="4"
                    :xl="4"
                  >
                    <v-text-field
                      class="validation-total"
                      :value="totalPonderacionEjes + '%'"
                      maxlength="50"
                      solo
                      dense
                      flat
                      readonly
                      background-color="white"
                      :error="$v.totalPonderacionEjes.$error"
                    >
                      <template v-slot:append>
                        <template v-if="!$v.totalPonderacionEjes.$error">
                          <img src="@/assets/img/sumatoriaCheck.svg" alt />
                        </template>
                        <template v-if="$v.totalPonderacionEjes.$error">
                          <v-popover placement="top-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <span
                                @click="$v.totalPonderacionEjes.$reset()"
                                v-close-popover
                              >
                                <span v-if="!$v.totalPonderacionEjes.between"
                                  >¡El valor total debe ser 100!</span
                                >
                              </span>
                            </template>
                          </v-popover>
                        </template>
                      </template>
                    </v-text-field>
                  </v-col>
                </v-row>
              </v-card>
            </v-col>
          </v-row>
        </v-sheet>
      </template>
    </template>

    <template>
      <v-dialog v-model="dialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar este eje?</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogDelete = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteTempEjeModelo()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="dialogDeleteDoubleConfirmation"
        persistent
        max-width="700px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar este eje?</strong>
            </div>
            <div class="pa-4">
              El eje
              <strong>
                {{
                  tempDeletingEjeModelo && tempDeletingEjeModelo.eje
                    ? tempDeletingEjeModelo.eje.descripcion
                    : ""
                }}
              </strong>
              tiene las siguientes disciplinas asignadas:
              <br />
              <template v-if="this.tempDeletingEjeModelo">
                <v-chip
                  v-for="(disciplina,
                  indexDisciplina) in tempDeletingEjeModelo.disciplinas_eje"
                  :key="indexDisciplina"
                  class="ma-2"
                >
                  {{
                    getDisciplinaFromMetadata(disciplina.id_disciplina)
                      .descripcion
                  }}
                </v-chip>
              </template>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogDeleteDoubleConfirmation = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteTempEjeModelo(true)"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogNewEje" persistent max-width="600px">
        <v-card style="border:1px solid #fff;">
          <v-card-title>
            <div class="titModal">
              <strong>Nuevo Eje</strong>
            </div>
          </v-card-title>
          <template v-if="isEditingEje">
            <Eje
              :finishEditingEje="finishEditingEje"
              :data="tempEditingEje"
              :metadata="metadata"
            />
          </template>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style>
.validation-total .v-input__control .v-input__slot .v-text-field__slot {
  border: #ffcc00 solid;
  height: 32px;
}
.validation-total.v-text-field > .v-input__control > .v-input__slot:before {
  border: none;
}
.v-list-item--disabled {
  display: none;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import Eje from "@/views/secure/modelo-franquicia/franquicias/modelos/components/Eje.vue";
import { required, between, requiredIf } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionEjesModelosFranquicia",
  components: {
    Eje
  },
  props: ["data"],
  data() {
    return {
      dialogDelete: false,
      dialogNewEje: false,
      dialogDeleteDoubleConfirmation: false,
      isEditingEje: false,
      tempEditingEje: null,
      tempDeletingEjeModelo: null,
      tempIndexEjeModeloDeleting: null
    };
  },
  validations: {
    modeloVuelidate: {
      nombre_modelo: {
        required
      },
      ejes_modelo: {
        required,
        $each: {
          id_eje: {
            required: requiredIf(object => {
              return !object.deleted;
            })
          },
          ponderacion: {
            required: requiredIf(object => {
              return !object.deleted;
            }),
            greaterZero: value => value > 0,
            ponderacionFaltante: function(value) {
              return (
                this.totalPonderacionEjes === 100 ||
                this.totalPonderacionEjesRestante < 0
              );
            },
            ponderacionSobrante: function(value) {
              return (
                this.totalPonderacionEjes === 100 ||
                0 < this.totalPonderacionEjesRestante
              );
            }
          }
        }
      }
    },
    totalPonderacionEjes: {
      between: between(100, 100)
    }
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    avalibleEjes() {
      let ejesFiltered;
      if (!this.metadata.ejes) {
        ejesFiltered = [];
      } else {
        ejesFiltered = JSON.parse(JSON.stringify(this.metadata.ejes));
      }
      return ejesFiltered.filter(itemEje => {
        this.modelo.ejes_modelo.forEach(itemEjeModelo => {
          if (itemEjeModelo.id_eje && itemEjeModelo.id_eje === itemEje.id_eje) {
            itemEje.disabled = true;
          }
        });
        return itemEje;
      });
    },
    modeloVuelidate() {
      const modeloVuelidate = JSON.parse(JSON.stringify(this.modelo));
      if (modeloVuelidate.ejes_modelo) {
        modeloVuelidate.ejes_modelo = modeloVuelidate.ejes_modelo.filter(
          itemEjeModelo => {
            return !itemEjeModelo.deleted;
          }
        );
      }
      return modeloVuelidate;
    },
    notEjes() {
      if (this.modeloVuelidate.ejes_modelo) {
        return this.modeloVuelidate.ejes_modelo.length === 0;
      } else {
        return false;
      }
    },
    totalPonderacionEjes() {
      let total = 0;
      if (this.modelo.ejes_modelo) {
        this.modelo.ejes_modelo.forEach(itemEje => {
          if (!itemEje.deleted) {
            total += isNaN(parseInt(itemEje.ponderacion))
              ? 0
              : parseInt(itemEje.ponderacion);
          }
        });
        return total;
      } else {
        return 0;
      }
    },
    totalPonderacionEjesRestante() {
      return 100 - this.totalPonderacionEjes;
    },
    modelo() {
      return this.data.modelo;
    },
    metadata() {
      return this.data.metadata;
    }
  },
  methods: {
    ejesActiveModelo() {
      if (this.modelo.ejes_modelo) {
        return this.modelo.ejes_modelo.filter(itemEjeModelo => {
          return !itemEjeModelo.deleted;
        });
      }
    },
    getDisciplinaFromMetadata(id_disciplina) {
      if (this.metadata.disciplinas) {
        let disciplinas_filtered = this.metadata.disciplinas.filter(
          itemDisciplina => itemDisciplina.id_disciplina === id_disciplina
        )[0];
        return disciplinas_filtered;
      }
    },
    addNewTempEjeModelo() {
      const tempNewEje = {
        ponderacion: 0,
        inserted: true,
        disciplinas_eje: []
      };
      if (this.modelo.id_modelo) {
        tempNewEje.id_modelo = this.modelo.id_modelo;
      }
      this.modelo.ejes_modelo.push(tempNewEje);
    },
    deleteTempEjeModelo(double) {
      if (
        this.tempDeletingEjeModelo.disciplinas_eje &&
        this.tempDeletingEjeModelo.disciplinas_eje.length > 0
      ) {
        if (double) {
          this.dialogDeleteDoubleConfirmation = false;
          this.tempDeletingEjeModelo.deleted = true;
          this.dialogDelete = false;
          this.tempDeletingEjeModelo.disciplinas_eje = [];
          this.refreshEjesModelo();
        } else {
          this.dialogDeleteDoubleConfirmation = true;
          this.dialogDelete = false;
        }
      } else {
        if (this.tempDeletingEjeModelo.id_eje_modelo) {
          this.tempDeletingEjeModelo.deleted = true;
          this.refreshEjesModelo();
        } else {
          this.deleteEjeModeloByIndex();
          this.tempIndexEjeModeloDeleting = null;
          this.tempDeletingEjeModelo = null;
        }
        this.dialogDelete = false;
      }
    },
    deleteEjeModeloByIndex() {
      this.modelo.ejes_modelo = this.modelo.ejes_modelo.filter(
        (itemEje, indexEje) => {
          return indexEje !== this.tempIndexEjeModeloDeleting;
        }
      );
    },
    refreshEjesModelo() {
      this.modelo.ejes_modelo = this.modelo.ejes_modelo.filter(itemEje => {
        return true;
      });
    },
    editTempEje(item) {
      this.isEditingEje = true;
      this.dialogNewEje = true;
      this.tempEditingEje = JSON.parse(JSON.stringify(item));
    },
    finishEditingEje() {
      this.tempEditingEje = null;
      this.isEditingEje = false;
      this.dialogNewEje = false;
    }
  },
  created() {}
};
</script>
